;; ##################################################################################
;; # ============================================================================== #
;; # MrEd Designer - splash-screen.ss                                               #
;; # http://mreddesigner.lozi.org                                                   #
;; # Copyright (C) Lozi Jean-Pierre, 2004 - mailto:jean-pierre@lozi.org             #
;; # ============================================================================== #
;; #                                                                                #
;; # This program is free software; you can redistribute it and/or                  #
;; # modify it under the terms of the GNU General Public License                    #
;; # as published by the Free Software Foundation; either version 2                 #
;; # of the License, or (at your option) any later version.                         #
;; #                                                                                #
;; # This program is distributed in the hope that it will be useful,                #
;; # but WITHOUT ANY WARRANTY; without even the implied warranty of                 #
;; # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                  #
;; # GNU General Public License for more details.                                   #
;; #                                                                                #
;; # You should have received a copy of the GNU General Public License              #
;; # along with this program; if not, write to the Free Software                    #
;; # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.    #
;; #                                                                                #
;; ##################################################################################

;; We first get the screen size (in pixels)...
(define-values (screen-w screen-h) (get-display-size))

;; Splash screen definition...
(define splash-screen (new frame% 
                           (label "MrEd Designer")
                           (parent #f)
                           (x (- (quotient screen-w 2) 218))
                           (y (- (quotient screen-h 2) 118))
                           (style '(no-resize-border))
                           (width 437) 
                           (height 236)))

;; Splash screen image loading...
(define splash-screen-logo (make-object bitmap% "images/logo.png" 'png #f))

;; Canvas definition...
(define splash-screen-canvas (new canvas% 
                                  (parent splash-screen)
                                  (min-width 437)
                                  (min-height 236)
                                  (paint-callback (lambda (canvas dc) (splash-screen-paint dc)))))

;; Paint callback definition...
(define (splash-screen-paint dc)
  (send dc draw-bitmap splash-screen-logo 0 0 'solid (make-object color% "black") #f))

;; This function shows the splash screen for the given time (in seconds)...
(define (splash-screen-show seconds)
  (send splash-screen show #t)
  (sleep/yield seconds)
  (send splash-screen show #f))

;; We show the splash screen for 1.5 seconds...
(splash-screen-show 1.5)